# CloudCasa Rancher Extension 
The CloudCasa Extension is designed to facilitate seamless one-click installation and monitoring of backup statuses within the Rancher environment. This extension features a central management interface and integrated status indicators throughout the Rancher platform.

Key Features of the Current Release:
1) **CloudCasa API Key Storage:** Enter your CloudCasa API Key once to enable easy access to the Cluster Management Panel.
2) **Cluster Management Panel:** Efficiently manage your cluster list with an intuitive panel that streamlines operations.
3) **One-Click Installation of CloudCasa Agent:** Simplify the deployment process with our one-click installation feature, allowing for rapid integration of the CloudCasa agent into your cluster.
4) **Cluster Detail Page:** View recent CloudCasa jobs, check coverage status, and quickly navigate to CloudCasa cluster pages.


<p align="middle">
   <img src="https://github.com/user-attachments/assets/48b1fda8-cd40-4831-9179-876bccd01c5c" />
   <img src="https://github.com/user-attachments/assets/47a79e5b-ecb5-46c1-bb7c-5113847c5ece" />
</p>

## Installation

### Prerequisites
1) Ensure you are running the Rancher version 2.10.0 or later.
2) Ensure you have access to an admin user. 

You have are different options to install the CloudCasa Rancher Extension, **you only need to do one of these to use the extension**. 

### Add a Repository
1) Log into Rancher.
2) From the Rancher Dashboard, open the hamburger menu in the top left corner and select "Extensions."
3) Open the dropdown in the top right corner and select "Manage Repositories."
4) Click the "Create" button in the top right corner of the page.
5) On the Create Repository page, enter the following information:

   a. Name: cloud-casa-extension

   b. Select the "Git repository containing Helm chart or cluster template definitions" radio option.

   c. Copy the repository link `https://github.com/catalogicsoftware/cloudcasa-rancher-extension.git` and paste it into the "Git Repo URL" text input field.

   d. Select the "Authentication" dropdown and choose "none" if it is not already selected.

   e. Click the "Create" button in the bottom right corner of the page.

7) After being redirected to the Repository Management page, you should see the repository downloading successfully. You can now return to the main "Extensions" page, click the "Available" tab, and then click "Install."
8) Once the installation is complete, you may need to reload the page to see the extension appear in the left sidebar.


### Using an index genereate by Helm
1) Log into Rancher.
2) From the Rancher Dashboard, open the hamburger menu in the top left corner and select "Extensions."
3) Open the dropdown in the top right corner and select "Manage Repositories."
4) Click the "Create" button in the top right corner of the page.
5) On the Create Repository page, enter the following information:

   a. Name: cloud-casa-extension

   b. Select the "http(s) URL to an index generated by Helm" radio option.

   c. Copy the repository link https://catalogicsoftware.github.io/cloudcasa-rancher-extension/ and paste it into the "Index URL" text input field.

   d. Select the "Authentication" dropdown and choose "none" if it is not already selected.

   e. Click the "Create" button in the bottom right corner of the page.

7) After being redirected to the Repository Management page, you should see the repository downloading successfully. You can now return to the main "Extensions" page, click the "Available" tab, and then click "Install."
8) Once the installation is complete, you may need to reload the page to see the extension appear in the left sidebar.

# Development
If you would like to know how to develop on this Rancher Extension, see the [Development Environment Setup Guide](DEVELOPMENT.md).
